Subject: Re: [Netconf] New Version Notification for draft-mahesh-netconf-binary-encoding-00.txt

From: Qin Wu <[email-masked]>
Date: Sun, 18 Mar 2018 08:43:37 +0000

7) There is no encoding of metadata in CBOR, it might be useful if that was also considered, probably that would end up being a separate draft.
7b) Related to 7, how would the <edit-config> operations (merge, create, remove,  etc) be encoded.
7c) Would errors also be reported using a binary encoding, or would they stay in XML?

[Qin]: Interesting case, how do we deal with XML encoding and Binary encoding coexisting case?
Juergen had a similar question. After discussing with him, we will clarify in the next version of the document that the encoding will be for everything above the Messages layer per Figure 1 of RFC 6241. So the answer to 7c is that it will stay in XML.

For 7b, and example conversion of a XML to JSON encoding would look like this:

In XML:

<rpc message-id="101" xmlns="urn:ietf:params:xml:ns:netconf:base:1.0">

<get-config>

  <source>

    <running/>

  </source>

  <filter type="subtree">

        <interface-configurations xmlns="http://cisco.com/ns/yang/Cisco-IOS-XR-ifmgr-cfg">

     <interface-configuration>

      <active>act</active>

      <interface-name>GigabitEthernet0/0/0/0</interface-name>

     </interface-configuration>

    </interface-configurations>

  </filter>

</get-config>

</rpc>

After switching to JSON encoding the same request would look something like (just noticed that type=“subtree” got dropped)

<rpc message-id="103" xmlns="urn:ietf:params:xml:ns:netconf:base:1.0">

{

  "ietf-netconf:get-config": {

    "source": {

      "running": null

   },

    "filter": {

      "interface-configurations": {

        “xmlns":"http://cisco.com/ns/yang/Cisco-IOS-XR-ifmgr-cfg",

        "interface-configuration": {

          "active": "act",

          "interface-name": "GigabitEthernet0/0/0/0"

        }

      }

    }

  }

}

</rpc>

[Qin]: I believe Conversion from XML to JSON has already been support internal YANG tool. But I am not sure we have tool to convert XML encoding to binary encoding.
Maybe CBOR has already done this.
8) Does there need to be any comment/considerations regarding YANG push and friends.
Yes, there are considerations for YANG push and friends drafts. Eric tells me that there is an ability in subscribed notifications to change the encoding mid-stream.

But in general, I'm supportive of IETF allowing binary encodings to be used in NETCONF/RESTCONF for devices that want to use them.  They seem to be particularly relevant to streaming telemetry related applications.
Agree.

Thanks,
Rob
On 22/02/2018 02:29, Mahesh Jethanandani wrote:
This short draft proposes a mechanism for NETCONF clients and servers to negotiate an alternate form of encoding, e.g. binary encoding.

Cheers.

Begin forwarded message:

From: [email-masked]<mailto:[email-masked]>
Subject: New Version Notification for draft-mahesh-netconf-binary-encoding-00.txt
Date: February 21, 2018 at 6:18:45 PM PST
To: "Jason Lam" <[email-masked]<mailto:[email-masked]>>, "Alfred Leung" <[email-masked]<mailto:[email-masked]>>, "Mahesh Jethanandani" <[email-masked]<mailto:[email-masked]>>

A new version of I-D, draft-mahesh-netconf-binary-encoding-00.txt
has been successfully submitted by Mahesh Jethanandani and posted to the
IETF repository.

Name:     draft-mahesh-netconf-binary-encoding
Revision: 00
Title:    Binary Encoding for NETCONF
Document date:   2018-02-23
Group:    Individual Submission
Pages:    6
URL:            https://www.ietf.org/internet-drafts/draft-mahesh-netconf-binary-encoding-00.txt
Status:         https://datatracker.ietf.org/doc/draft-mahesh-netconf-binary-encoding/
Htmlized:       https://tools.ietf.org/html/draft-mahesh-netconf-binary-encoding-00
Htmlized:       https://datatracker.ietf.org/doc/html/draft-mahesh-netconf-binary-encoding-00

Abstract:
  This document describes a method by which a NETCONF [RFC6241] client
  and server can negotiate an alternate form of encoding.

  This document updates RFC 6241.

Please note that it may take a couple of minutes from the time of submission
until the htmlized version and diff are available at tools.ietf.org<http://tools.ietf.org/>.

The IETF Secretariat

Mahesh Jethanandani
[email-masked]<mailto:[email-masked]>

_______________________________________________

Netconf mailing list

[email-masked]<mailto:[email-masked]>

https://www.ietf.org/mailman/listinfo/netconf

Mahesh Jethanandani
[email-masked]<mailto:[email-masked]>